pootpoot = LibStub("AceAddon-3.0"):NewAddon("pootpoot", "AceEvent-3.0", "AceConsole-3.0")
local pootpoot = pootpoot

pootpoot.title = "pootpoot"
pootpoot.version = GetAddOnMetadata(pootpoot.title, "Version")

local CombatLog_Object_IsA = CombatLog_Object_IsA

local COMBATLOG_OBJECT_NONE = COMBATLOG_OBJECT_NONE
local COMBATLOG_FILTER_MINE = COMBATLOG_FILTER_MINE

local COMBAT_EVENTS = {
  ["SWING_DAMAGE"] = "DAMAGE",
  ["RANGE_DAMAGE"] = "DAMAGE",
  ["SPELL_DAMAGE"] = "DAMAGE",
  ["SPELL_PERIODIC_DAMAGE"] = "DAMAGE",
  ["DAMAGE_SHIELD"] = "DAMAGE",
  ["DAMAGE_SPLIT"] = "DAMAGE",
  ["SWING_MISSED"] = "MISS",
  ["RANGE_MISSED"] = "MISS",
  ["SPELL_MISSED"] = "MISS",
  ["SPELL_PERIODIC_MISSED"] = "MISS",
  ["DAMAGE_SHIELD_MISSED"] = "MISS",
  ["SPELL_INTERRUPT"] = "INTERRUPT",
  ["SPELL_CAST_SUCCESS"] = "SUCCESS",
}

local options = { 
	type = "group",
	args = {
		ui = {
			order = 1,
			type = "execute",
			name = "PootPoot GUI",
			desc = "Opens Configuation Dialog",
			func = "OpenPootConfig",
			guiHidden = true,
		},
		profiles = {
			order = 2,
			type = "execute",
			name = "PootPoot Profiles GUI",
			desc = "Opens Profile Configuation Dialog",
			func = "OpenPootProfileConfig",
			guiHidden = true,
		},
		desc = {
			type = "description",
			name = "PootPoot " .. pootpoot.version .. "\n",
			cmdHidden = true,
		},
		warriorspells = {
			type = "group",
			handler = pootpoot,
			name = "Warrior",
			desc = "Warrior Spells",
			args = {
				warriordesc = {
					type = "description",
					name = "Warrior Options\n\nYou can use these options to set strings that can be output to /say.\nThe strings can be set to output on crit, and/or percentage chance.",
					cmdHidden = true,
				},
				chargegrp = {
					type = "group",
					handler = pootpoot,
					name = "Charge",
					desc = "Charge Options",
					args = {
						charge = {
							order = 1,
							type = "input",
							name = "Charge",
							desc = "Charge, Intercept and Intervene string.",
							usage = "<string[;string...]>",
							get = "GetStringVar",
							set = "SetStringVar",
						},
						chargetgl = {
							order = 2,
							type = "toggle",
							name = "Charge Toggle",
							desc = "Toggles the display of the Interrupt string.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						chargechance = {
							order = 3,
							type = "range",
							name = "Charge Chance",
							desc = "Chance of Charge string out of 100.",
							min = 0,
							max = 1,
							step = 0.01,
							get = "GetChance",
							set = "SetChance",
							isPercent = true,
						}
					}
				},
				executegrp = {
					type = "group",
					handler = pootpoot,
					name = "Execute",
					desc = "Execute Options",
					args = {
						execute = {
							order = 4,
							type = "input",
							name = "Execute",
							desc = "Execute string.",
							usage = "<string[;string...]>",
							get = "GetStringVar",
							set = "SetStringVar",
						},
						executetgl = {
							order = 5,
							type = "toggle",
							name = "Execute Toggle",
							desc = "Toggles the display of the Execute string.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						executecrit = {
							order = 6,
							type = "toggle",
							name = "Execute Crit Toggle",
							desc = "Toggles the display of the Execute string only on crits.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						executechance = {
							order = 7,
							type = "range",
							name = "Execute Chance",
							desc = "Chance of Execute string out of 100.",
							min = 0,
							max = 1,
							step = 0.01,
							get = "GetChance",
							set = "SetChance",
							isPercent = true,
						}
					}
				},
				mortalstrikegrp = {
					type = "group",
					handler = pootpoot,
					name = "Mortal Strike",
					desc = "Mortal Strike Options",
					args = {
						mortalstrike = {
							order = 8,
							type = "input",
							name = "Mortal Strike",
							desc = "Mortal Strike string. Outputs on crit.",
							usage = "<string[;string...]>",
							get = "GetStringVar",
							set = "SetStringVar",
						},
						mortalstriketgl = {
							order = 9,
							type = "toggle",
							name = "Mortal Strike Toggle",
							desc = "Toggles the display of the Mortal Strike string.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						mortalstrikecrit = {
							order = 10,
							type = "toggle",
							name = "Mortal Strike Crit Toggle",
							desc = "Toggles the display of the Mortal Strike string only on crits.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						mortalstrikechance = {
							order = 11,
							type = "range",
							name = "Mortal Strike Chance",
							desc = "Chance of Mortal Strike string out of 100.",
							min = 0,
							max = 1,
							step = 0.01,
							get = "GetChance",
							set = "SetChance",
							isPercent = true,
						}
					}
				},
				bloodthirstgrp = {
					type = "group",
					handler = pootpoot,
					name = "Bloodthirst",
					desc = "Bloodthirst Options",
					args = {
						bloodthirst = {
							order = 12,
							type = "input",
							name = "Bloodthirst",
							desc = "Bloodthirst string. Outputs on crit.",
							usage = "<string[;string...]>",
							get = "GetStringVar",
							set = "SetStringVar",
						},
						bloodthirsttgl = {
							order = 13,
							type = "toggle",
							name = "Bloodthirst Toggle",
							desc = "Toggles the display of the Bloodthirst string.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						bloodthirstcrit = {
							order = 14,
							type = "toggle",
							name = "Bloodthirst Crit Toggle",
							desc = "Toggles the display of the Bloodthirst string only on crits.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						bloodthirstchance = {
							order = 15,
							type = "range",
							name = "Bloodthirst Chance",
							desc = "Chance of Bloodthirst string out of 100.",
							min = 0,
							max = 1,
							step = 0.01,
							get = "GetChance",
							set = "SetChance",
							isPercent = true,
						}
					}
				},
				rampagegrp = {
					type = "group",
					handler = pootpoot,
					name = "Rampage",
					desc = "Rampage Options",
					args = {
						rampage = {
							order = 16,
							type = "input",
							name = "Rampage",
							desc = "Rampage string.",
							usage = "<string[;string...]>",
							get = "GetStringVar",
							set = "SetStringVar",
						},
						rampagetgl = {
							order = 17,
							type = "toggle",
							name = "Rampage Toggle",
							desc = "Toggles the display of the Rampage string.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						rampagechance = {
							order = 18,
							type = "range",
							name = "Rampage Chance",
							desc = "Chance of Rampage string out of 100.",
							min = 0,
							max = 1,
							step = 0.01,
							get = "GetChance",
							set = "SetChance",
							isPercent = true,
						}
					}
				}
			}
		},
		magespells = {
			type = "group",
			handler = pootpoot,
			name = "Mage",
			desc = "Mage Spells",
			args = {
				warriordesc = {
					type = "description",
					name = "Mage Options\n\nYou can use these options to set strings that can be output to /say.\nThe strings can be set to output on crit, and/or percentage chance.",
					cmdHidden = true,
				},
				firegrp = {
					type = "group",
					handler = pootpoot,
					name = "Fire",
					desc = "Fire Options",
					args = {
						fire = {
							type = "input",
							name = "Fire",
							desc = "Fireball, Fire Blast, Pyroblast and Dragon's Breath string. Outputs on crit.",
							usage = "<string[;string...]>",
							get = "GetStringVar",
							set = "SetStringVar",
						},
						firetgl = {
							type = "toggle",
							name = "Fire Toggle",
							desc = "Toggles the display of the Fire string.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						firecrit = {
							type = "toggle",
							name = "Fire Crit Toggle",
							desc = "Toggles the display of the Fire string only on crits.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						firechance = {
							type = "range",
							name = "Fire Chance",
							desc = "Chance of Fire string out of 100.",
							min = 0,
							max = 1,
							step = 0.01,
							get = "GetChance",
							set = "SetChance",
							isPercent = true,
						}
					}
				},
				frostgrp = {
					type = "group",
					handler = pootpoot,
					name = "Frost",
					desc = "Frost Options",
					args = {
						frost = {
							type = "input",
							name = "Frost",
							desc = "Frostbolt and Cone of Cold string. Outputs on crit.",
							usage = "<string[;string...]>",
							get = "GetStringVar",
							set = "SetStringVar",
						},
						frosttgl = {
							type = "toggle",
							name = "Frost Toggle",
							desc = "Toggles the display of the Frost string.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						frostcrit = {
							type = "toggle",
							name = "Frost Crit Toggle",
							desc = "Toggles the display of the Frost string only on crits.",
							get = "GetToggleVar",
							set = "SetToggleVar",
						},
						frostchance = {
							type = "range",
							name = "Frost Chance",
							desc = "Chance of Frost string out of 100.",
							min = 0,
							max = 1,
							step = 0.01,
							get = "GetChance",
							set = "SetChance",
							isPercent = true,
						}
					}
				}
			}
		},
		general = {
			order = 3,
			type = "group",
			handler = pootpoot,
			name = "General",
			desc = "General Spells and Events",
			args = {
				ding = {
					order = 1,
					type = "input",
					name = "Ding",
					desc = "Level up string.",
					usage = "<string[;string...]>",
					get = "GetStringVar",
					set = "SetStringVar",
				},
				dingtgl = {
					order = 2,
					type = "toggle",
					name = "Ding Toggle",
					desc = "Toggles the display of the level up string.",
					get = "GetToggleVar",
					set = "SetToggleVar",
				},
				interrupt = {
					order = 3,
					type = "input",
					name = "Interrupt",
					desc = "Interrupt string. Works on healing spells.",
					usage = "<string[;string...]>",
					get = "GetStringVar",
					set = "SetStringVar",
				},
				interrupttgl = {
					order = 4,
					type = "toggle",
					name = "Interrupt Toggle",
					desc = "Toggles the display of the Interrupt string.",
					get = "GetToggleVar",
					set = "SetToggleVar",
				},
				interruptchance = {
					order = 5,
					type = "range",
					name = "Interrupt Chance",
					desc = "Chance of interrupt String display.",
					min = 0,
					max = 1,
					step = 0.01,
					get = "GetChance",
					set = "SetChance",
					isPercent = true,
				}
			}
		}
	}
}

local defaults = {
	profile = {
		charge = "Charge!",
		chargetgl = true,
		chargechance = 1,
		execute = "Execute!",
		executetgl = true,
		executecrit = true,
		executechance = 1,
		mortalstrike = "Mortal Strike!",
		mortalstriketgl = true,
		mortalstrikecrit = true,
		mortalstrikechance = 1,
		bloodthirst = "Bloodthirst!",
		bloodthirsttgl = true,
		bloodthirstcrit = true,
		bloodthirstchance = 1,
		rampage = "Rampage!",
		rampagetgl = true,
		rampagechance = 1,
		fire = "Fire!",
		firetgl = false,
		firecrit = true,
		firechance = 1,
		frost = "Frost!",
		frosttgl = false,
		frostcrit = true,
		frostchance = 1,
		ding = "Ding!",
		dingtgl = false,
		interrupt = "Interrupt!",
		interrupttgl = true,
		interruptchance = 1,
	},
}

local optionsFrame
local profilesFrame

function pootpoot:ChatCommand(input)
	LibStub("AceConfigCmd-3.0").HandleCommand(pootpoot, "ppc", "pootpoot", input)
end

function pootpoot:OpenPootConfig()
	LibStub("AceConfigDialog-3.0"):SetDefaultSize("pootpoot", 500, 350)
	LibStub("AceConfigDialog-3.0"):Open("pootpoot", configFrame)
end

function pootpoot:OpenPootProfileConfig()
	InterfaceOptionsFrame_OpenToFrame(self.profilesFrame)
end

function pootpoot:PootOnYou(input)
	local t=UnitName("target")
	if( t ) then
		if( t ~= self.player ) then
			SendChatMessage("poots on %t.", "EMOTE", nil, nil)
		else
			local genderTable = { "its", "his", "her" }
			SendChatMessage('poots ' .. genderTable[UnitSex(t)] .. ' pants.', "EMOTE", nil, nil)
		end
	else
		SendChatMessage("poots.", "EMOTE", nil, nil)
	end
end

function pootpoot:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("pootpootDB", defaults, "Default")

	LibStub("AceConfig-3.0"):RegisterOptionsTable("pootpoot", options)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("PootPoot Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	--LibStub("AceConfig-3.0"):RegisterOptionsTable("PootPoot Profiles", profileoptions)
	--self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("pootpoot", "PootPoot")
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("PootPoot Profiles", "PootPoot")
	self:RegisterChatCommand("pootpoot", "ChatCommand")
	self:RegisterChatCommand("ppc", "ChatCommand")
	self:RegisterChatCommand("poot", "PootOnYou")

	self.player = UnitName("player")
end

function pootpoot:OnEnable()
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","ParseCombat")
end

function pootpoot:OnDisable()
end

local function DispPootMsg( dmessage, dmsgtype )
	local tbl = { strsplit(";", dmessage) }
	SendChatMessage( tbl[math.random(#tbl)], dmsgtype, nil, nil )
end

function pootpoot:GetStringVar(info)
	return self.db.profile[info[#info]]
end

function pootpoot:SetStringVar(info, newValue)
	self.db.profile[info[#info]] = newValue
end

function pootpoot:GetToggleVar(info)
	return self.db.profile[info[#info]]
end

function pootpoot:SetToggleVar(info, newValue)
	self.db.profile[info[#info]] = newValue
end

function pootpoot:GetChance(info)
	return self.db.profile[info[#info]]
end

function pootpoot:SetChance(info, newValue)
	self.db.profile[info[#info]] = newValue
end

function pootpoot:PLAYER_LEVEL_UP(args)
	if (self.db.profile.dingtgl) then
		DispPootMsg( self.db.profile.ding, "SAY" )
	end
end

function pootpoot:ParseCombat(arg1, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	local etype = COMBAT_EVENTS[event]
	--DEFAULT_CHAT_FRAME:AddMessage(event)
  	if not etype then
  		return
  	end
	
	local fromPlayer, fromPet
	if (sourceName and not CombatLog_Object_IsA(sourceFlags, COMBATLOG_OBJECT_NONE) ) then
		fromPlayer = CombatLog_Object_IsA(sourceFlags, COMBATLOG_FILTER_MINE)
	end
	
	--if not from player or pet, then end
	if not fromPlayer then return end
	
	local healtot, healamt, parent
	local amount, school, resisted, blocked, absorbed, critical, glancing, crushing
	local spellId, spellName, spellSchool, missType, powerType, extraAmount, environmentalType, extraSpellId, extraSpellName, extraSpellSchool
  	local text, texture, message, inout, color
	
	if etype == "DAMAGE" then
		if event == "SWING_DAMAGE" then
			amount, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
		else
			spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
			texture = select(3, GetSpellInfo(spellId))
		end
    		text = tostring(amount)
    		if event == "SPELL_DAMAGE" then
    			if spellName == "Execute" then
    				if (self.db.profile.executetgl) then
    					if (self.db.profile.executecrit) then
						if (critical) then
							if (math.random(100) <= (self.db.profile.executechance*100)) then
								DispPootMsg( self.db.profile.execute, "SAY" )
							end
						end
					elseif (math.random(100) <= (self.db.profile.executechance*100)) then
						DispPootMsg( self.db.profile.execute, "SAY" )
					end
				end
    			elseif spellName == "Mortal Strike" then
    				if (self.db.profile.mortalstriketgl) then
    					if (self.db.profile.mortalstrikecrit) then
						if (critical) then
							if (math.random(100) <= (self.db.profile.mortalstrikechance*100)) then
								DispPootMsg( self.db.profile.mortalstrike, "SAY" )
							end
						end
					elseif (math.random(100) <= (self.db.profile.mortalstrikechance*100)) then
						DispPootMsg( self.db.profile.mortalstrike, "SAY" )
					end
				end
			elseif spellName == "Fireball" or spellName == "Pyroblast" or spellName == "Fire Blast" or spellName == "Dragon's Breath" then
				if (critical) then
					DispPootMsg( self.db.profile.fire, "SAY" )
				end
    			elseif spellName == "Frostbolt" or spellName == "Cone of Cold" then
				if (critical) then
					DispPootMsg( self.db.profile.frost, "SAY" )
				end
			elseif spellName == "Bloodthirst" then
    				if (self.db.profile.bloodthirsttgl) then
    					if (self.db.profile.bloodthirstcrit) then
						if (critical) then
							if (math.random(100) <= (self.db.profile.bloodthirstchance*100)) then
								DispPootMsg( self.db.profile.bloodthirst, "SAY" )
							end
						end
					elseif (math.random(100) <= (self.db.profile.bloodthirstchance*100)) then
						DispPootMsg( self.db.profile.bloodthirst, "SAY" )
					end
				end
    			end
    		end
	end
	if etype == "SUCCESS" then
		if event == "SPELL_CAST_SUCCESS" then
			spellId, spellName, spellSchool = select(1, ...)
			if spellName == "Charge" or spellName == "Intercept" or spellName == "Intervene" then
				if (self.db.profile.chargetgl) then
					if (math.random(100) <= (self.db.profile.chargechance*100)) then
						DispPootMsg( self.db.profile.charge, "SAY" )
					end
				end
			elseif spellName == "Rampage" then
				if (self.db.profile.rampagetgl) then
					if (math.random(100) <= (self.db.profile.rampagechance*100)) then
						DispPootMsg( self.db.profile.rampage, "SAY" )
					end
				end
			end
		end
	end
	if etype == "INTERRUPT" then
		if event == "SPELL_INTERRUPT" then
			if (self.db.profile.interrupttgl) then
				spellId, spellName, spellSchool, extraSpellID, extraSpellName, extraSpellSchool = select(1, ...)
				if string.find(extraSpellName, "[hH]eal") or string.find(extraSpellName, "[rR]egrowth") or extraSpellName == "Flash of Light" or extraSpellName == "Holy Light" then
					if (math.random(100) <= (self.db.profile.interruptchance*100)) then
						DispPootMsg( self.db.profile.interrupt, "SAY" )
					end
				end
			end
		end
	end
end

--DEFAULT_CHAT_FRAME:AddMessage("Message")